@echo off
chcp 65001 >nul 2>&1   & rem 切换到 UTF-8 编码
setlocal enabledelayedexpansion

rem 设定默认起始端口或接受手动指定
if "%~1"=="" (
    echo 未指定端口，尝试自动分配可用端口（起始：8000）...
    call :AutoPort 8000
    echo 成功分配到端口：!PORT!
) else (
    set "PORT=%~1"
    rem 验证端口是否为合法数字
    echo !PORT! | findstr /r "^[0-9]*$" >nul || (
        echo 错误：端口必须为数字。
        pause
        exit /b 1
    )
    set /a "PORT=!PORT!"
    if !PORT! lss 1 (
        echo 错误：端口 %PORT% 过小（最小为 1）。
        pause
        exit /b 1
    )
    if !PORT! gtr 65535 (
        echo 错误：端口 %PORT% 过大（最大为 65535）。
        pause
        exit /b 1
    )
    rem 检查指定端口是否可用
    netstat -ano | findstr /C:"TCP" | findstr /C:":%PORT% " | findstr "LISTENING" >nul && (
        echo 错误：端口 %PORT% 已被占用。
        pause
        exit /b 1
    )
)

rem 检查 Python 是否存在
where python >nul 2>&1 || (
    echo 错误：未找到 Python，请确认已安装并添加至系统 PATH。
    pause
    exit /b 1
)

echo 正在启动 HTTP 服务器（端口：%PORT%）...
echo 访问地址：http://localhost:%PORT%/
python -m http.server %PORT%
if %ERRORLEVEL% neq 0 (
    echo 错误：HTTP 服务器启动失败。
    pause
    exit /b 1
)

rem 若通过双击运行，则暂停窗口
echo %CMDCMDLINE% | find /I /C " /C " >nul
if %ERRORLEVEL% equ 0 pause

endlocal
exit /b 0

rem 自动寻找可用端口的子程序
:AutoPort
set START_PORT=%~1
for /l %%i in (%START_PORT%,1,65535) do (
    netstat -ano | findstr /C:"TCP" | findstr /C:":%%i " | findstr "LISTENING" >nul
    if !ERRORLEVEL! neq 0 (
        set "PORT=%%i"
        goto :EOF
    )
)
echo 错误：没有可用端口（%START_PORT%-65535）。
pause
exit /b 1
